/*

Package alvin converts between protobuf RPCs and REST-style HTTP requests.

A service's API should be defined in the protobuf interface description
language. Each method should have a "google.api.http" annotation to control
how the request is converted to or from an HTTP request. Individual message
fields can use "json_name" annotations to control how request or response
bodies are converted to or from JSON.

References

https://cloud.google.com/service-management/reference/rpc/google.api#httprule

https://developers.google.com/protocol-buffers/docs/proto3#json

*/
package alvin
